
#include "TreeToXML.h"
#include <string>
#include <iostream>
using namespace std;

// should we output all the individuals into an xml file ?
bool xmloutputon = false;
// the file to output to
fstream xmlfile;
// hte name of this file
char* xmlfilename = 0;


/* should not be called if xmloutputon is false ! */
void SetupXMLOutput()
{
	if( ! xmlfile.is_open() )
	{
		xmlfile.open(xmlfilename, fstream::out);
	}

	// ecris l'entete du fichier :
	xmlfile<<"<project id=\"1\" name=\"ECJAVA and XML GP test\" description=\"test\" date=\"today\" organization=\"SNU SC LAB\" fund=\"$$$\"> \n";
 	xmlfile<<"\t<experiments> \n\
\t\t<experiment id=\"1\" date=\"14th June\" description=\"gp individual generation\"> \n\
\t\t\t<treatments> \n\
\t\t\t\t<treatment id=\"1\" description=\"Test treatment\"> \n\
\t\t\t\t\t<trials> \n\
\t\t\t\t\t\t<trial id=\"1\"> \n\
\t\t\t\t\t\t\t<generations> \n ";
}

/* should not be called if xmloutputon is false ! */
void FinishXMLOutput()
{	
	if( xmlfile.is_open() )
	{
		xmlfile.close();
	}
}

void Decaller(int n)
{
	for(int i=0 ; i<n ; i++ )
	{
		xmlfile<<"\t";
	}
}

void ConvertToXML(individual v, int gen, int ind)
{

	static int lastgen = -1;
	if( lastgen != gen )
	{             
		if(lastgen != -1 )
		{
			Decaller(8);
			xmlfile<<"</generation> \n";
		}  
		lastgen = gen;
		Decaller(8);
		xmlfile<<"<generation id=\""<<gen<<"\"> \n";
		Decaller(9);
 		xmlfile<<"<individuals> \n";
	}
	Decaller(10);
	xmlfile<<"<individual id=\""<<ind<<"\"> \n ";
	Decaller(11);
    xmlfile<<"<representations> \n";
	Decaller(12);
    xmlfile<<"<representation id=\"1\" type=\"tree\"> \n ";
	stree s = Decode(v, FALSE);
	PrintToXML(s.root,13);
}

void PrintToXML( node* n , int decallage )
{
	Decaller(decallage);
	if( n->children == NULL )
	{
		// leaf node
		xmlfile<< "<" << NODE <<" type=\"TERMINAL\" value=\"";
		if( n->name[0] == 'R' )
			xmlfile<<n->value;
		else
			xmlfile<<n->name;
		xmlfile<< "\" />\n";	
	}
	else
	{
		xmlfile<<"<"<< NODE<< " type=\"NON TERMINAL\" value=\""<<n->name<<"\" >\n";

		Decaller(decallage+1);
		xmlfile<<"<"<<CHILDREN<<">\n";

		// affiche les fils :
		PrintToXML(n->children, decallage+2);
		Decaller(decallage+1);
		xmlfile<<"</"<<CHILDREN<<">\n";
		Decaller(decallage);
		xmlfile<<"</"<<NODE<<">\n";
	}
	// affiche les freres :
	if( n->sibling != NULL )
	{
			PrintToXML(n->sibling, decallage);
	}

}
