/*
 * DeleteNodeAddList.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

#include "adtable.h"

#ifdef _SP_MODE
void DeleteNodeAddList(addlist &al, sp_address p) {
	sp_address t;
#else
void DeleteNodeAddList(addlist &al, address *p) {
	address *t;
#endif

	if (p == al.head) {
		al.head = (al.head)->next;
	} else {
		t = al.head;

		while (t->next != p) {
			t = t->next;
		}

		t->next = p->next;
	}
	#ifdef _SP_MODE
	check_ptr (p);
	#else
	delete p;
	#endif
	al.card--;

	if (al.card == 0) {
		al.head = NULL;
	}
}
