/*
 * DeleteNodeSlist.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National Univ.
 */

#include "adtable.h"

#ifdef _SP_MODE
void DeleteNodeSlist(slist &s, sp_snode p) {
	sp_snode t;
#else
void DeleteNodeSlist(slist &s, snode *p) {
	snode *t;
#endif

	if (p == s.head) {
		s.head = (s.head)->next;
	} else {
		t = s.head;

		while (t->next != p) {
			t = t->next;
		}
		t->next = p->next;
	}
	#ifdef _SP_MODE
	check_ptr(p);
	#else
	delete p;
	#endif
	s.card--;

	if (s.card == 0) {
		s.head = NULL;
	}
}
