/*
 * GetTreeID.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National Univ.
 */

#include "adtable.h"

SIZE GetTreeID(slist s) {

	#ifdef _SP_MODE
	sp_snode p;
	#else
	snode *p;
	#endif
	double h;
	assert(!EmptySlist(s));
	h = Next_Double();
	p = s.head;

	while ((h > 0) && p) {
		h = h - p->prob;
		if (h > 0) {
			p = p->next;
		}
	}

	if (p) {
		return p->id;
	} else {
		cout << endl << "Adjunction distribution error!!!";
		exit(1);
	}

	return 0;
}

