/*
 * variable.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

#include "dtree.h"
#include "../util/util.h"

#ifdef _SP_MODE
void insertNewBeta(BYTE addno, SIZE i, sp_address v, SIZE j, sp_dnode t, sp_dnode p, sp_dnode q) {
#else
void insertNewBeta(BYTE addno, SIZE i, address * v, SIZE j, dnode * t, dnode * p, dnode * q) {
#endif

	addno = i; //the index of the open address
	//Find a random beta tree in the source list of the address
	i = 0;
	v = adtable[_opendnode->id].head;
	while (i < addno) {
		v = v->next;
		i++;
	}
	j = GetTreeID(v->source); //choose the jth source tree
	t = MakeDNode(j, addno); //make the new beta
	//Insert New Beta
	p = _opendnode->children;
	if (p == NULL) {
		_opendnode->children = t;
	} else {
		insertBeta(q, p, addno, t);
	}
}

#ifdef _SP_MODE
void chooseRandomNode(sp_dnode s, BYTE childrenno, sp_dnode & p,
		boost::shared_array<BOOL> & check, SIZE & i) {
#else
void chooseRandomNode(dnode * s, BYTE childrenno, dnode * p, BOOL * & check, SIZE & i) {
#endif

	//Then choose one open node as random
	_opendnodeno = IRandom(1u, _opendnodeno);
	_opendnode = NULL;
	_countorfind = FALSE;

	PreorderDNode(s); //result is in _opendnode
	//Find the number of open addresses
	childrenno = 0;
	p = _opendnode->children;
	check = new BOOL[adtable[_opendnode->id].card];
	assert(check!=NULL);

	for (i = 0; i < adtable[_opendnode->id].card; i++) {
		check[i] = FALSE;
	}

	while (p) {
		check[p->addno] = TRUE;
		childrenno++;
		p = p->sibling;
	}

	childrenno = IRandom(1u, ABSDIFF(adtable[_opendnode->id].card,childrenno));
	i = 0;

	while ((i < adtable[_opendnode->id].card) && (childrenno > 0)) {
		if (!check[i]) {
			childrenno--;
		}
		if (childrenno > 0) {
			i++;
		}
	}
}

#ifdef _SP_MODE
BOOL AddBeta(sp_dnode s) {
	sp_dnode p, t, q;
	boost::shared_array<BOOL> check;
	sp_address v;
#else
BOOL AddBeta(dnode *s) {
	dnode *p, *t, *q;
	BOOL *check;
	address *v;
#endif

	BYTE childrenno, addno;
	SIZE j, i;

	//First count to see how many node is still open
	_opendnodeno = 0u;
	_countorfind = TRUE;
	_doitdnode = CountOpenDNode;
	PreorderDNode(s); //result is in _opendnodeno
	assert (_opendnodeno>=0);

	// Should eventually be in a #IFDEF
	if (_opendnodeno <= 0) {
		return FALSE;
	}

	chooseRandomNode(s, childrenno, p, check, i);
	#ifdef _SP_MODE
		check_ptr(check);
	#else
		delete[] check;
	#endif;
	insertNewBeta(addno, i, v, j, t, p, q);

	return TRUE;
}
