/*
 * variable.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

#include "dtree.h"
#include "../util/util.h"

#ifdef _SP_MODE
void insertNewBeta(BYTE addno, BYTE childrenno, sp_address v, BYTE j, BYTE i, sp_dnode t, sp_dnode p, sp_dnode q){
#else
void insertNewBeta(BYTE addno, BYTE childrenno, address * v, BYTE j, BYTE i, dnode * t, dnode * p, dnode * q){
#endif

    addno = childrenno; //next address (in increasing maner)
    v = adtable[_opendnode->id].head;
    j = 0; //find this address
    while(j < addno){
        v = v->next;
        j++;
    }
    i = GetTreeID(v->source); //choose one beta tree as random
    //Find it
    t = MakeDNode(i, addno); //creat the node
    p = _opendnode->children;
    if (p == NULL) {
		_opendnode->children = t;
	} else {
		insertBeta(q, p, addno, t);
	}
}

#ifdef _SP_MODE
void chooseRandomNode(sp_dnode s, boost::shared_array<BOOL> & check, BYTE & i, sp_dnode & p, BYTE & childrenno){
#else
void chooseRandomNode(dnode * s, BOOL * check, BYTE & i, dnode * & p, BYTE & childrenno){
#endif

    //Then choose the first open node
    _opendnodeno = 1u;
    _opendnode = NULL;
    _countorfind = FALSE;
    LevelorderDNode(s); //result is _opendnode
    //Then choose the first open address
    check = new BOOL[adtable[_opendnode->id].card];
    assert(check!=NULL);
    for (i = 0; i < adtable[_opendnode->id].card; i++) {
		check[i] = FALSE;
	}
    p = _opendnode->children;
    while (p) {
		check[p->addno] = TRUE;
		p = p->sibling;
	}
    childrenno = 0;
    while(check[childrenno]){
        childrenno++;
    }
}

#ifdef _SP_MODE
BOOL AddFullBeta(sp_dnode s) {
	sp_dnode t, p, q;
	boost::shared_array<BOOL> check;
	sp_address v;
#else
BOOL AddFullBeta(dnode *s) {
	dnode *t, *p, *q;
	BOOL *check;
	address *v;
#endif

    BYTE childrenno, addno;
    BYTE i, j;

    //First count to see how many node is still open
    _opendnodeno = 0u;
    _countorfind = TRUE;
    _doitdnode = CountOpenDNode;
    PreorderDNode(s); //result is in _opendnodeno
    assert (_opendnodeno>=0);

    if (_opendnodeno <= 0) {
		return FALSE;
	}

    chooseRandomNode(s, check, i, p, childrenno);

	#ifdef _SP_MODE
	check_ptr (check);
	#else
	delete[] check;
	#endif

	insertNewBeta(addno, childrenno, v, j, i, t, p, q);

    return TRUE;
}
