/*
 * variable.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

#include "dtree.h"

#ifdef _SP_MODE
sp_dnode CopyDNode(sp_dnode s) {

	sp_dnode t, p, q;
#else
dnode *CopyDNode(dnode *s) {

	dnode *t, *p, *q;
#endif
	if (s) {
		t = new dnode;

		assert(t!=NULL);
		t->id = s->id;
		t->addno = s->addno;
		t->lexlist = CopyLList(s->lexlist);
		t->sibling = NULL;
		t->children = NULL;
		q = s->children;
		t->children = CopyDNode(q);
		p = t->children;

		while (q) {
			p->sibling = CopyDNode(q->sibling);
			q = q->sibling;
			p = p->sibling;
		}

		return t;
	}

	#ifdef _SP_MODE
	sp_dnode nl;
	return nl;
	#else
	return NULL;
	#endif
}
