/*
 * variable.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

#include "dtree.h"

#ifdef _SP_MODE
sp_node CopyNode2(sp_node s, sp_node parent, SIZE treeindex, addlist &newadd) {

	sp_node t, p, q;
	sp_address v;
#else
node *CopyNode2(node *s, node *parent, SIZE treeindex, addlist &newadd) {

	node *t, *p, *q;
	address *v;
#endif
	BOOL found;
	slist st;

	if (s) {
		t = MakeNode(s->name, s->value);

		if (s == _oldfoot2){
			_newfoot2 = t;
		}

		//check whether s is in the addlist of the tree h
		v = adtable[treeindex].head;
		found = FALSE;

		while (v && !found){
			if (v->addr == s){
				found = TRUE;
			}else{
				v = v->next;
			}
		}

		if (found) {
			IniSlist(st);
			AddHeadAddList(newadd, st, t, parent, v->constraint);
		}

		q = s->children;
		t->children = CopyNode2(q, t, treeindex, newadd);
		p = t->children;

		while (q) {
			p->sibling = CopyNode2(q->sibling, t, treeindex, newadd);
			q = q->sibling;
			p = p->sibling;
		}

		return t;
	}
	#ifdef _SP_MODE
	sp_node nl;
	return nl;
	#else
	return NULL;
	#endif
}
