/*
 * DNodeBranchCount.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

#include "dtree.h"

#ifdef _SP_MODE
BOOL DNodeCmp(sp_dnode t, sp_dnode s) {
#else
BOOL DNodeCmp(dnode *t, dnode *s) {
#endif

	if ((t != NULL) && (s != NULL)) {
		if ((t->id == s->id) && (t->addno == s->addno)) {
			#ifdef _SP_MODE
			sp_dnode p(t->children), q(s->children);
			#else
			dnode *p = t->children, *q = s->children;
			#endif
			BOOL b = TRUE;

			while (b && (p != NULL) && (q != NULL)) {
				b = DNodeCmp(p, q);
				p = p->sibling;
				q = q->sibling;
			}

			if (b == FALSE) {
				return b;
			} else if ((p == NULL) && (q == NULL)) {
				return TRUE;
			} else {
				return FALSE;
			}
		} else {
			return FALSE;
		}
	} else if ((t == NULL) && (s == NULL)) {
		return TRUE;
	} else {
		return FALSE;
	}
}
