/*
 * CountOpenDNode.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

#include "dtree.h"

#ifdef _SP_MODE
void DeleteDNode(sp_dnode t) {

	sp_dnode q, p;
#else
void DeleteDNode(dnode *t) {

	dnode *q, *p;
#endif

	if (t) {
		if (t->children == NULL) {
			DeleteSDNode(t);
		} else {
			p = t->children;

			while (p) {
				q = p->sibling;
				DeleteDNode(p);
				p = q;
			}
			DeleteSDNode(t);
		}
	}
}
