/*
 * CountOpenDNode.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

#include "dtree.h"

#ifdef _SP_MODE
void DeleteLeave(sp_dnode s, sp_dnode parent) {

	sp_dnode t;
#else
void DeleteLeave(dnode *s, dnode *parent) {

	dnode *t;
#endif

	if (_leavecount > 0) {
		if (s->children == NULL) {
			_leavecount--;
			if (_leavecount == 0) {
				if (s == parent->children) {
					parent->children = s->sibling;
				} else {
					t = parent->children;
					while (t->sibling != s) {
						t = t->sibling;
					}
					t->sibling = s->sibling;
				}
				DeleteSDNode(s);
			}
		} else {
			t = s->children;
			while (t) {
				DeleteLeave(t, s);
				t = t->sibling;
			}
		}
	}
}
