/*
 * DisplayDTree.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "dtree.h"

#ifdef _SP_MODE
void DisplayDTree(sp_dnode r) {

	sp_dnode p;
#else
void DisplayDTree(dnode *r) {

	dnode *p;
#endif

	if (r) {
		cout << (int) r->id << " address: " << (int) r->addno << flush;
		p = r->children;

		if (p) {
			cout << "(" << flush;
			while (p) {
				DisplayDTree(p);
				if (p->sibling) {
					cout << "," << flush;
				}
				p = p->sibling;
			}
			cout << ")" << flush;
		}
	}
}
