/*
 * DNodOrder.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "dtree.h"

#ifdef _SP_MODE
unsigned int GetHeightDNode(sp_dnode t) {
#else
unsigned int GetHeightDNode(dnode *t) {
#endif

	if (t->children == NULL) {
		return 0;
	} else {
		unsigned int c, max = 0;
		#ifdef _SP_MODE
		sp_dnode p(t->children);
		#else
		dnode *p = t->children;
		#endif
		while (p) {
			c = GetHeightDNode(p);
			if (c > max)
				max = c;
			p = p->sibling;
		}

		return max + 1;
	}
}
