/*
 * DNodOrder.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "dtree.h"

#ifdef _SP_MODE
void LevelorderDNode(sp_dnode t) {
	sp_dnode p1, p2;
#else
void LevelorderDNode(dnode *t) {
	dnode *p1, *p2;
#endif
	queue q;

	if (t) {
		IniQueue(q);
		AddQueue(q, t);
		while (!EmptyQueue(q)) {
			p1 = PopQueue(q);
			_doitdnode(p1);
			p2 = p1->children;
			while (p2) {
				AddQueue(q, p2);
				p2 = p2->sibling;
			}
		}
	}
}
