/*
 * DNodOrder.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "dtree.h"

#ifdef _SP_MODE
sp_dnode LocateOpenAdd(sp_dnode s, unsigned int index, BYTE &add) {

	boost::shared_array<BOOL> check;
	sp_dnode p;
#else
dnode *LocateOpenAdd(dnode *s, unsigned int index, BYTE &add) {

	BOOL *check;
	dnode *p;
#endif
	BYTE i;
	_openaddno = index;
	_cf = FALSE;
	_stop = FALSE;
	_opendnodeadd = NULL;
	_doitdnode = CountOpenAddDNode;
	PreorderDNode(s);
	// *n=_opendnodeadd;
	//compute the address number

	//marking the occupied addresses
	assert (_opendnodeadd!=NULL);
	p = _opendnodeadd->children;
	check = new BOOL[adtable[_opendnodeadd->id].card];
	assert(check!=NULL);

	for (i = 0; i < adtable[_opendnodeadd->id].card; i++) {
		check[i] = FALSE;
	}

	while (p) {
		check[p->addno] = TRUE;
		p = p->sibling;
	}

	//picking up the opening address
	i = 0;
	while ((_openaddindex > 0) && (i < adtable[_opendnodeadd->id].card)) {
		if (!check[i]) {
			_openaddindex--;
		}
		if (_openaddindex > 0) {
			i++;
		}
	}
	#ifdef _SP_MODE
	check_ptr (check);	
	#else
	delete[] check;
	#endif
	add = i;
	return _opendnodeadd;
}
