/*
 * ComputeFitness.cpp
 *
 *  Created on: 2010. 5. 15.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "evolution.h"

void ComputeFitness() {

	unsigned int i, pos;
	double min, sum = 0;

	//First Compute Raw fitness
	for (i = 0; i < poplen; i++) {
		oldpop[i].fitness = ComputeIndividualRF(oldpop[i]);
	}

	//local search
	Greedy(0);
	//Second Compute standardized fitness
	//for(i=0;i<poplen;i++)
	//  oldpop[i].fitness=(double) NUMFITCASE-oldpop[i].fitness;
	//Find the best of the current population
	min = oldpop[0].fitness;
	pos = 0;
	sum = 0;

	for (i = 1; i < poplen; i++) {

		if (oldpop[i].fitness < min) {
			min = oldpop[i].fitness;
			pos = i;
		}

		sum += oldpop[i].fitness;
	}

	//   GreedyIndividual(oldpop[pos],500);
	//copy the best and average
	bestcurrent[gen] = CopyIndividual(oldpop[pos], TRUE);
	average[gen] = sum / poplen;

	if (bestcurrent[gen].fitness == 0) {
		SuccPredicate = TRUE;
	}

	//Third Compute Adjusted fitness
	AdjustFitness();
	//Finally Compute nomarlized fitness
	NormalizeFitness();
}
