/*
 * Evolution.cpp
 *
 *  Created on: 2010. 5. 15.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "evolution.h"

#include "../TreeToXML.h"


void Evolution() {

	unsigned int i, j, l, k;
	#ifdef _SP_MODE
	sa_individual temp;
	#else
	individual *temp;
	#endif
	individual parent1, parent2;
	//Initialize a population
	RampInit(2, 10, 0.0);
	gen = 0;


	if( xmloutputon )
	{
		SetupXMLOutput();		
	}

	while ((gen < generation) && !SuccPredicate) {

		/** ajout jerome */
		for(int i=0; i<poplen; i++)
		{
			ConvertToXML( oldpop[i] ,gen, i);
		}
		/** fin ajout */

		cout << "Generation...";
		ComputeFitness();
		cout << gen << endl << flush;
		//"...Best Fitness:"<<bestcurrent[gen].fitness;
		//for(i=0;i<poplen;i++)
		//DisplayIndividual(oldpop[i]);
		//if(gen%5==1)  
		//for(i=0;i<poplen;i++)
		//  if(Flip(0.4))
		//   DeleteIntron(oldpop[i]);
		l = 0;

		while (l < poplen) {

			i = TourSelect(TOURSIZE);
			j = TourSelect(TOURSIZE);
			parent1 = CopyIndividual(oldpop[i], TRUE);
			parent2 = CopyIndividual(oldpop[j], TRUE);

			if (Flip(pcross)) {
				if (OldSubTreeSwap2(parent1, parent2, newpop[l], newpop[l + 1], FALSE, 0, 0.9)) {
					ncross++;
				} else {
					newpop[l] = CopyIndividual(parent1, FALSE);
					newpop[l + 1] = CopyIndividual(parent2, FALSE);
				}
			} else {
				newpop[l] = CopyIndividual(parent1, FALSE);
				newpop[l + 1] = CopyIndividual(parent2, FALSE);
			}

			//mutation test
			if (Flip(preplace)) {
				if (ReplaceSubTree2(newpop[l], 0, FALSE, TRUE, 5, 0.9)) {
					nreplace++;
				}
			}

			if (Flip(preplace)) {
				if (ReplaceSubTree2(newpop[l + 1], 0, FALSE, TRUE, 5, 0.9)) {
					nreplace++;
				}
			}
			//Point replacment
			/*  if(Flip(preplace))
			 if(PointReplace(newpop[l]))
			 nreplace++;
			 if(Flip(preplace))
			 if(PointReplace(newpop[l+1]))
			 nreplace++;*/
			//replication test

			if (Flip(prep)) {
				if (Replicate(newpop[l], TRUE)) {
					nrep++;
				}
			}

			if (Flip(prep)) {
				if (Replicate(newpop[l + 1], TRUE)) {
					nrep++;
				}
			}

			l += 2;
		}

		gen++;

		for (k = 0; k < poplen; k++) {
			DeleteDNode(oldpop[k].chrom);
		}

		temp = oldpop;
		oldpop = newpop;
		newpop = temp;
	}

	if( xmloutputon )
	{
		FinishXMLOutput();		
	}
}
