/*
 * GreedyIndividual.cpp
 *
 *  Created on: 2010. 5. 15.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "evolution.h"

void GreedyIndividual(individual &p, unsigned int times) {

	individual q;
	unsigned int i;

	for (i = 0; i < times; i++) {

		q = CopyIndividual(p, TRUE);

		if (Flip(0.5)) {
			Insert(q, 1, FALSE);
		} else {
			Delete(q, 1);
		}

		q.fitness = NUMFITCASE - ComputeIndividualRF(q);

		if (q.fitness < p.fitness) {
			DeleteDNode(p.chrom);
			p = CopyIndividual(q, FALSE);
		}
	}
}
