/*
 * Init.cpp
 *
 *  Created on: 2010. 5. 15.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "evolution.h"

//*****************************************************
//This Function initializes for the program           *
//*****************************************************
void Init() {
	//Initialize global variables
	//Loading Elementary trees and Adjoining Table
	LoadETree();
	GetERconst = ERGenerate;//DefaultConstant
	//Initialize population
	poplen = POPSIZE;
	assert (poplen%2 == 0); //It better be even (otherwise, bugs)
	oldpop = new individual[poplen];
	assert(oldpop!=NULL);
	newpop = new individual[poplen];
	assert(newpop!=NULL);
	//Initialize Probabilities
	pcross = PCROSS;
	preplace = PREPLACE;
	pdelete = PDELETE;
	pinsert = PINSERT;
	pmutate = PMUTATE;
	prep = PREP;
	ptran = PTRAN;
	//Initializes satistics
	ncross = 0;
	nreplace = 0;
	ninsert = 0;
	ndelete = 0;
	nmutate = 0;
	nrep = 0;
	ntran = 0;
	//Number of generations
	generation = NGEN;
	bestcurrent = new individual[generation];
	assert(bestcurrent!=NULL);
	average = new double[generation];
	assert(average!=NULL);
	//Some global variables
	SuccPredicate = FALSE;
	_cut = TRUE;
	//Set up fitness cases
	SetFitCase();
}
