/*
 * GenShapeTree.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "genetic.h"

#ifdef _SP_MODE
sp_dnode GenShapeTree(SIZE &size, SIZE starttree, BYTE addno, BOOL shape) {

	sp_dnode t;
#else
dnode *GenShapeTree(SIZE &size, SIZE starttree, BYTE addno, BOOL shape) {

	dnode *t;
#endif
	unsigned int j, asize;
	t = MakeDNode(starttree, addno);
	asize = 1;

	if (shape) //Full tree
	{
		for (j = 1; j < size; j++) {
			if (AddFullBeta(t)) {
				asize++;
			}
		}
	} else {//random shape tree
		for (j = 1; j < size; j++) {
			if (AddBeta(t)) {
				asize++;
			}
		}
	}
	size = asize;

	return t;
}
