/*
 * GetCrossPoint.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "genetic.h"

unsigned int GetCrossPoint(individual p) {

	unsigned int i, pos;
	double s;
	_pointdis = new double[p.size];
	assert(_pointdis!=NULL);
	_dnodeindex1 = 0;
	_doitdnode = DNodeProb;
	PreorderDNode(p.chrom);
	//normalise the distribution exclude the root
	s = 0;

	for (i = 1; i < p.size; i++){
		s += _pointdis[i];
	}

	for (i = 1; i < p.size; i++){
		_pointdis[i] = _pointdis[i] / s;
	}

	//choose the crossover point
	s = Next_Double();
	pos = 1;

	while ((pos + 1 < p.size) && (s > 0)) {
		s -= _pointdis[pos];

		if (s > 0){
			pos++;
		}
	}
	#ifdef _SP_MODE
	check_ptr(_pointdis);
	#else
	delete[] _pointdis;
	#endif

	return pos + 1;
}
