/*
 * OldSubTreeSwap.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "genetic.h"
#include "../util/util.h"

BOOL OldSubTreeSwap(individual parent1, individual parent2, individual &child1,
		individual &child2, BOOL fairsize, unsigned int diff) {
	unsigned int crosspoint1, crosspoint2, j, temp1;
	SIZE size1, size2;
	#ifdef _SP_MODE
		sp_dnode dnodeparent1, dnodeparent2, dnode1, dnode2, temp2;
		sp_address p;
		sp_snode t;
	#else
		dnode *dnodeparent1, *dnodeparent2, *dnode1, *dnode2, *temp2;
		address *p;
		snode *t;
	#endif
	BOOL found1, found2, act;
	unsigned int i;
	BYTE index;
	llist l;
	j = 0;

	while (j < MAXATEMPT) {
		getCrossOverPoints(crosspoint1, parent1, dnode1, dnodeparent1);
		getCrossOverPoints(crosspoint2, parent2, dnode2, dnodeparent2);
		index = dnode1->addno;
		checkAdjoint(p, dnodeparent1, i, index, t, found1, dnode2);

		if (found1) {
			index = dnode2->addno;
			checkAdjoint(p, dnodeparent2, i, index, t, found2, dnode1);
			if (found2) {//they are compatible
				act = TRUE;
				//calculate the size of the two sub-trees
				size1 = GetSizeDNode(dnode1, TRUE);
				size2 = GetSizeDNode(dnode2, TRUE);

				setAct(fairsize, size1, size2, diff, act, parent1, parent2);
				if (act) {//swapping
					swapTree(temp1, dnode1, dnode2, l, temp2);

					//recompute size and branch
					recomputeSizeNBranch(child1, parent1, size2, size1, dnode1);
					recomputeSizeNBranch(child2, parent2, size1, size2, dnode2);

					return TRUE;
				}
			}
		}
		j++; //Next attempt
	}
	return FALSE;
}
