/*
 * OldSubTreeSwap2.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "genetic.h"
#include "../util/util.h"


BOOL OldSubTreeSwap2(individual &parent1, individual &parent2,
		individual &child1, individual &child2, BOOL fairsize,
		unsigned int diff, double prob) {

	BOOL a, b;
	BOOL found, found2, act;
	unsigned int i, j, crosspoint1, crosspoint2;
	SIZE size1, size2;
	#ifdef _SP_MODE
		sp_dnode dnodeparent1, dnodeparent2, dnode1, tp1, tp2;
		sp_address p;
		sp_snode t;
	#else
		dnode *dnodeparent1, *dnodeparent2, *dnode1, *tp1, *tp2;
		address *p;
		snode *t;
	#endif
	BYTE addindex;
	individual tmp;
	j = 0;

	while (j < MAXATEMPT) {
		//First check if the crossoverpoint is null node or not
		a = Flip(prob);
		b = Flip(prob);

		if (a && b) {//if both are not NULL
			return OldSubTreeSwap(parent1, parent2, child1, child2, fairsize,
					diff);
		} else if (a || b) {
			if (!a && b) {
				copyIndividual(tmp, parent1, parent2);
			}

			//get the crossoverpoints
			getCrossOverPoints(crosspoint1, parent1, dnode1, dnodeparent1);

			crosspoint2 = IRandom(1u, CountOpenAdd(parent2.chrom));
			dnodeparent2 = LocateOpenAdd(parent2.chrom, crosspoint2, addindex);

			//check if dnode1 could adjoint to dnodeparent2
			checkAdjoint(p, dnodeparent2, i, addindex, t, found2, dnode1);

			if (found2) {//if they are compatible
				act = TRUE;
				//canculate the size of the two sub-trees
				size1 = GetSizeDNode(dnode1, TRUE);
				size2 = 0;
				checkAndSetAct(fairsize, size1, size2, diff, act, parent1, parent2);

				if (act) {
					swapParents(tp1, dnodeparent1, dnode1, addindex, dnodeparent2, found, tp2);
					recomputeSizeNBranch(child1, parent1, size2, size1);
					recomputeSizeNBranch(child2, parent2, size1, size2, dnode1);

					//if the parents were swapped then the children
					if (!a && b) {
						copyIndividual(tmp, parent1, parent2);
						copyIndividual(tmp, child1, child2);
					}
					// cout<<"Exiting Act!"<<endl;
					return TRUE;

				}
			}
		}//end of (a || b)

		j++; //Next attempt
	}

	return FALSE;
}
