/*
 * RampInit.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "genetic.h"

void RampInit(unsigned int minl, unsigned int maxl, double percentage) {//(minl>=2)

	unsigned int i, j;
	SIZE treeid;
	assert(minl>=MINSIZE);

	for (i = 0; i < poplen; i++) {
		oldpop[i].size = IRandom(minl, maxl);
		//choosing one alpha at random
		treeid = IRandom(1, numalpha);
		//find the alpha tree;
		j = 0;

		while (treeid > 0) {
			if (IsAlpha(etree[j])) {
				treeid--;
			}
			if (treeid > 0) {
				j++;
			}
		}

		if (Flip(percentage)) {
			oldpop[i].chrom = GenShapeTree(oldpop[i].size, j, 0, TRUE);
		} else {
			oldpop[i].chrom = GenShapeTree(oldpop[i].size, j, 0, FALSE);
		}

		oldpop[i].branch = GetAVGDNode(oldpop[i].chrom);
	}
}
