/*
 * ReplaceSubTree2.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "genetic.h"
#include "../util/util.h"

#ifdef _SP_MODE
void recomputeSizeNBranch(individual & child, unsigned int k, sp_dnode dnode1)
#else
void recomputeSizeNBranch(individual & child, unsigned int k, dnode * dnode1)
#endif
{
	if (child.size > MAXSIZE) {//randomly cut
		for (k = MAXSIZE; k < child.size; k++) {
			DeleteBeta(dnode1);
		}
		child.size = MAXSIZE;
	}
	child.branch = GetAVGDNode(child.chrom);
}

BOOL ReplaceSubTree2(individual &child, SIZE size, BOOL shape, BOOL fairsize,
		unsigned int diff, double prob) {
	#ifdef _SP_MODE
		sp_dnode parentdnode1, dnode1, tp1, tp2;
		sp_address p;
	#else
		dnode *parentdnode1, *dnode1, *tp1, *tp2;
		address *p;
	#endif
	BOOL a, found;
	unsigned int replacepoint, j, k;
	SIZE size1;
	BYTE i, addindex;
	j = 0;

	while (j < MAXATEMPT) {
		a = Flip(prob);

		if (a) {
			return ReplaceSubTree(child, size, shape, fairsize, diff);
		} else {
			addindex = 0;

			//grow a tree at a NULL node
			replacepoint = IRandom(1, CountOpenAdd(child.chrom));
			parentdnode1 = LocateOpenAdd(child.chrom, replacepoint, addindex);
			//cout<<replacepoint<<" Address:"<<(int)addindex<<endl;

			if (!fairsize) { //if fairsize = FALSE then the size of mutation is specified
				size1 = size;
			} else {
				//otherwise it is beween 0 and diff
				size1 = IRandom(0, diff);//increase size
			}

			//generate a tree
			if ((size1 > 0) && (child.size < MAXSIZE) && ((child.size + size1
					<= MAXSIZE) || _cut)) {
				//find the replace tree for dnode
				//find the address
				p = adtable[parentdnode1->id].head;
				i = 0;
				while (i < addindex) {
					p = p->next;
					i++;
				}
				//randomly choose a tree
				k = GetTreeID(p->source);
				dnode1 = GenShapeTree(size1, k, addindex, shape);
				//attach to the tree
				dnode1->sibling = NULL;
				//attach dnode1 to the Null address of Dnode2 using addindex
				tp1 = parentdnode1->children;
				if (tp1 == NULL) {
					parentdnode1->children = dnode1;
				} else {
					increaseOrderInsert(found, tp2, tp1, addindex, dnode1,
							parentdnode1);
				}

				//Recalculate the size
				child.size = child.size + size1;
				recomputeSizeNBranch(child, k, dnode1);

				return TRUE;
			} //if size1>0
		}// else grow a tree at NULL node

		j++;
	}
	return FALSE;
}
