/*
 * UniformInit.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "genetic.h"

void UniformInit(unsigned int minl, unsigned int maxl) {

	unsigned int j, i;
	SIZE treeid;
	assert(minl>=MINSIZE);

	for (i = 0; i < poplen; i++) {
		oldpop[i].size = IRandom(minl, maxl);
		//choosing one alpha at random
		treeid = IRandom(1, numalpha);
		//find the alpha tree;
		j = 0;

		while (treeid > 0) {
			if (IsAlpha(etree[j])) {
				treeid--;
			}
			if (treeid > 0) {
				j++;
			}
		}

		oldpop[i].chrom = GenShapeTree(oldpop[i].size, j, 0, FALSE);
		oldpop[i].branch = GetAVGDNode(oldpop[i].chrom);
	}
}
