/*
 * InitList.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National Univ.
 */

#include "lexicon.h"

#ifdef _SP_MODE
void BuildLListNode(sp_node s, llist &l) {
#else
void BuildLListNode(node *s, llist &l) {
#endif

	LEXSIZE i, j;

	#ifdef _SP_MODE
	sp_node p;
	#else
	node *p;
	#endif
	double value;

	if (s) {

		if (s->children == NULL) {//lexicon only at leaves
			// find in the vocab
			i = 0;

			while ((i < lexnum) && strcmp(s->name, vocab[i].name)) {
				i++;
			}

			if (i < lexnum) {//found
				j = GetLexemeID(i);
				if ((vocab[i].lexemes[j].lex)->name[0] == 'R') { //ephemeral constant
					value = GetERconst((vocab[i].lexemes[j].lex)->name);
				} else {
					value = VOIDVALUE;
				}
				AddTailLList(l, i, j, value);
			}

		} else {
			p = s->children;
			while (p) {
				BuildLListNode(p, l);
				p = p->sibling;
			}
		}
	}
}
