/*
 * InitList.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "lexicon.h"


#ifdef _SP_MODE
void DSubstituteLexiconNode(sp_node s, llist &l) {

	sp_node p, lex;
	sp_lnode t;
#else
void DSubstituteLexiconNode(node *s, llist &l) {

	node *p, *lex;
	lnode *t;
#endif

	if (s) {

		if (s->children == NULL) {//lexicon only at leaves
			//find the lexicon at the head
			t = l.head;

			if (t) {
				if (!strcmp(s->name, vocab[t->lexiconid].name)) {
					_oldfoot = NULL;
					lex	= CopyNode(vocab[t->lexiconid].lexemes[t->lexemeid].lex);
					strcpy(s->name, lex->name);
					if (s->name[0] == 'R') {
						s->value = t->value;
					}
					s->children = lex->children;
					#ifdef _SP_MODE
					check_ptr(lex);
					#else
					delete lex;
					#endif
					DeleteHeadLList(l);
				}
			}
		} else {
			p = s->children;

			while (p) {
				DSubstituteLexiconNode(p, l);
				p = p->sibling;
			}
		}
	}
}
