/*
 * InitList.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "lexicon.h"

#ifdef _SP_MODE
sp_node GetLexeme(LEXSIZE lexid) {
	sp_node s;
#else
node *GetLexeme(LEXSIZE lexid) {
	node *s;
#endif
	LEXSIZE i;
	double r;
	r = Next_Double();
	i = 0;

	while ((r > 0) && (i < vocab[lexid].card)) {
		r -= vocab[lexid].lexemes[i].prob;
		if (r > 0){
			i++;
		}
	}

	if (i < vocab[lexid].card) {

		_oldfoot = NULL;
		s = CopyNode(vocab[lexid].lexemes[i].lex);
		return s;
	} else {
		cout << endl << "Lexeme Distribution Error!!!";
		exit(1);
	}

	#ifdef _SP_MODE
	// return empty pointer;
	sp_node k;
	#else
	return NULL;
	#endif
}
