/*
 * InitList.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "lexicon.h"

#ifdef _SP_MODE
void SubstituteLexicon(sp_node s) {

	sp_node p, lex;
#else
void SubstituteLexicon(node *s) {

	node *p, *lex;
#endif

	LEXSIZE i;

	if (s) {
		//the lexicon must be at leaves
		if (s->children == NULL) {
			//check if it is in the vocab
			i = 0;

			while ((i < lexnum) && strcmp(s->name, vocab[i].name)) {
				i++;
			}

			if (i < lexnum) //if found
			{
				lex = GetLexeme(i);
				strcpy(s->name, lex->name);

				if (s->name[0] == 'R') {
					s->value = GetERconst(lex->name);
				} else {
					s->value = VOIDVALUE;
				}

				s->children = lex->children;
				#ifdef _SP_MODE
				check_ptr(lex);
				#else
				delete lex;
				#endif
			}

		} else {
			p = s->children;

			while (p) {
				SubstituteLexicon(p);
				p = p->sibling;
			}
		}

	}
}
