/*
 * MarkingDtree2.cpp
 *
 *  Created on: 2010. 5. 15.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "prune.h"

void setSubCodeType(BOOL & flag) {
	if (flag) {
		_subcodetype = TRUE; //subcode type1
	} else {
		_subcodetype = FALSE; //subcode type2
	}
}

#ifdef _SP_MODE
void doMarking(sp_dnode & t, double & f, individual & v, BOOL flag) {
#else
void doMarking(dnode * & t, double & f, individual & v, BOOL flag) {
#endif
	if (flag) {
		t->id = -t->id;
	} else {
		t->id = -(t->id + numetree);
	}

	f = ComputeIndividualRF(v);

	if (_effordes) { //detect the most effective
		if (fabs(f - _rawfitness2) < _mloss) {
			_subcode = t;
			_mloss = fabs(f - _rawfitness2);
			setSubCodeType(flag);
		}
	} else if (fabs(f - _rawfitness2) > _mloss) {//detect the most destructive
		_subcode = t;
		_mloss = fabs(f - _rawfitness2);
		setSubCodeType(flag);
	}

	if (flag) {
		t->id = -t->id;
	} else {
		t->id = -(t->id + numetree);
	}
}

#ifdef _SP_MODE
void MarkingDtree2(sp_dnode t, sp_dnode parent, individual &v) { //marking sub code of type1 and type 2
	sp_dnode p;
#else
	void MarkingDtree2(dnode *t, dnode *parent, individual &v) { //marking sub code of type1 and type 2
		dnode *p;
#endif

	double f;

	if (parent) {
		doMarking(t, f, v, true);
		if (RootAdjoined(t)) {
			doMarking(t, f, v, false);
		}

		p = t->children;
		while (p) {
			MarkingDtree2(p, t, v);
			p = p->sibling;
		}
	}
}
