/*
 * OldMarkingDtree1.cpp
 *
 *  Created on: 2010. 5. 15.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "prune.h"

#ifdef _SP_MODE
void markSubTree(sp_dnode & p, sp_dnode & t, individual & v) {
#else
void markSubTree(dnode * & p, dnode * & t, individual & v) {
#endif
	p = t->children;
	while (p) {
		OldMarkingDtree1(p, v);
		p = p->sibling;
	}
}

#ifdef _SP_MODE
void OldMarkingDtree1(sp_dnode t, individual &v) { //use for sub-code of type 1 only (i.e complete subtree)
	sp_dnode p;
#else
void OldMarkingDtree1(dnode *t, individual &v) { //use for sub-code of type 1 only (i.e complete subtree)
	dnode *p;
#endif

	double f;
	SIZE size1;

	if (t) {
		//compute the size
		size1 = GetSizeDNode(t, TRUE);
		if (_activesize - size1 >= MINSIZE) {//only do the marking if the result bigger than MIN SIZE
			t->id = -t->id;//temporary marked off
			f = ComputeIndividualRF(v); //compute the new fitness

			// cout<<endl<<"Fitness:"<<f;
			// cout<<endl<<"Active size:"<<_activesize;
			if (fabs(f - _rawfitness) <= _variance) {//if the change is insignificant
				_activesize -= size1;
			} else {
				t->id = -t->id;
				markSubTree(p, t, v);
			}
		} else {
			markSubTree(p, t, v);
		}
	}
}
