/*
 * OldMarkingDtree2.cpp
 *
 *  Created on: 2010. 5. 15.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "prune.h"

#ifdef _SP_MODE
void OldMarkingDtree2(sp_dnode t, sp_dnode parent, individual &v) //marking subcode of type 1 only
{
	sp_dnode p;
#else
void OldMarkingDtree2(dnode *t, dnode *parent, individual &v) //marking subcode of type 1 only
{
	dnode *p;
#endif
	double f;

	if (parent) {//excluding the root

		t->id = -t->id;//temporary marked off
		f = ComputeIndividualRF(v); //compute the new fitness

		if (_effordes) { //detect the most effective
			if (fabs(f - _rawfitness2) < _mloss) {
				_subcode = t;
				_mloss = fabs(f - _rawfitness2);
			}
		} else if (fabs(f - _rawfitness2) > _mloss) {
			_subcode = t;
			_mloss = fabs(f - _rawfitness2);
		}

		t->id = -t->id;
		p = t->children;

		while (p) {
			OldMarkingDtree2(p, t, v);
			p = p->sibling;
		}
	}
}
