//This file contain the for marking and pruning for TAG3P
//Programmed by NXH
#include "../gconst.h"
#include "../dtree/dtree.h"
#include "../genetic/genetic.h"
#include "../evolution/evolution.h"

//********************************************************************
//Marking and pruning non-fitness contributing parts of an individual*
//********************************************************************
extern SIZE _activesize;
extern double _variance, _rawfitness;

#ifdef _SP_MODE
void OldMarkingDtree1(sp_dnode t, individual &v);

void MarkingDtree1(sp_dnode t, individual &v);
#else
void OldMarkingDtree1(dnode *t, individual &v);

void MarkingDtree1(dnode *t, individual &v);
#endif

void OldDeleteIntron(individual &v);

void DeleteIntron(individual &v);

//*******************************************************************************
//Marking and extracting the most effective (destructive) parts of an individual*
//*******************************************************************************
extern double _rawfitness2, _mloss;
extern BOOL _effordes, _subcodetype;
#ifdef _SP_MODE
extern sp_dnode _subcode;
#else
extern dnode *_subcode;
#endif

#ifdef _SP_MODE
void OldMarkingDtree2(sp_dnode t, sp_dnode parent, individual &v);

void MarkingDtree2(sp_dnode t, sp_dnode parent, individual &v);

sp_dnode OldSubCodeDetect(individual &v, BOOL type);

sp_dnode SubCodeDetect(individual &v, BOOL type, BOOL &subcodetype);
#else

void OldMarkingDtree2(dnode *t, dnode *parent, individual &v);

void MarkingDtree2(dnode *t, dnode *parent, individual &v);

dnode *OldSubCodeDetect(individual &v, BOOL type);

dnode *SubCodeDetect(individual &v, BOOL type, BOOL &subcodetype);
#endif


