/*
 * InitRanGen.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

//Initialize the random generator
#include "random.h"

void InitRanGen() {

	idum = (long) -12345;
	IA = (long) 16807;
	IM = 2147483647;
	AM = (1.0 / IM);
	IQ = 127773;
	IR = (long) 2836;
	NTAB = 32u;
	NDIV = (1.0 + (IM - 1.0) / (double) NTAB);
	EPS = 1.2e-7;
	RNMX = (1.0 - EPS); //largest double less than 1
	iy = 0;

	#ifdef _SP_MODE
  	iv.reset(new long[NTAB]);
	#else
  	iv=new long[NTAB]; assert(iv!=NULL);
	#endif
}

