/*
 * InitRanGen.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

//Initialize the random generator
#include "random.h"

double Next_Double() {

	int j; //can't be an unsigned int, because the loop can create 0-1
	//which would be evaluated as a large number for unsigned int
	long k;
	double temp;

	if (idum <= 0 || !iy) {

		if (-idum < 1) {
			idum = 1;
		} else {
			idum = -idum;
		}

		for (j = NTAB + 7; j >= 0; j--) {

			k = (long) (idum / (double) IQ);
			idum = IA * (idum - k * IQ) - IR * k;
			if (idum < 0) {
				idum += IM;
			}
			if (j < NTAB) {
				iv[j] = idum;
			}
		}

		iy = iv[0];
	}

	k = (long) (idum / (double) IQ);
	idum = IA * (idum - k * IQ) - IR * k;

	if (idum < 0) {
		idum += IM;
	}

	j = (int) (iy / NDIV);
	iy = iv[j];
	iv[j] = idum;

	if ((temp = AM * iy) > RNMX) {
		return RNMX;
	} else {
		return temp;
	}
}
