/*
 * InitRanGen.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

//Initialize the random generator

#include "random.h"

double Next_Gaussian(double mean, double stdev) {

	double x = (double) Next_Gaussian();
	return (double) (x * stdev + mean);
}

double Next_Gaussian() {

	static unsigned int iset = 0; //Probably, should be a more restrictive type
	static double gset;
	double fac, rsq, v1, v2;

	if (iset == 0) {

		do {
			v1 = 2.0 * Next_Double() - 1.0;
			v2 = 2.0 * Next_Double() - 1.0;
			rsq = v1 * v1 + v2 * v2;
		} while (rsq >= 1.0 || rsq == 0.0);

		fac = sqrt(-2.0 * log(rsq) / (double) rsq);
		gset = v1 * fac;
		iset = 1;

		return v2 * fac;

	} else {

		iset = 0;
		return gset;
	}
}
