/*
 * AdjointTree.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

#include "stree.h"

#ifdef _SP_MODE
stree AdjointTree(stree beta, stree gama, sp_node add, sp_node parent) {
#else
stree AdjointTree(stree beta, stree gama, node *add, node *parent) {
#endif

	stree t, v;
	t = beta;
	v = gama;

	if (parent == NULL) {//adjoin at root
		(t.foot)->children = (v.root)->children;
		t.foot = v.foot;
		#ifdef _SP_MODE
		check_ptr(v.root);
		#else
		delete v.root;
		#endif
		return t;
	} else {
		#ifdef _SP_MODE
		sp_node p, q;
		#else
		node *p, *q;
		#endif
		p = parent->children;
		q = p;

		while ((p != add) && p) {
			q = p;
			p = p->sibling;
		}

		if (p == q) {//adjoin at the first children
			parent->children = t.root;
			(t.root)->sibling = p->sibling;
			(t.foot)->children = p->children;
			#ifdef _SP_MODE
			check_ptr(p);
			#else
			delete p;
			#endif
			return v;
		} else {
			q->sibling = t.root;
			(t.root)->sibling = p->sibling;
			(t.foot)->children = p->children;
			#ifdef _SP_MODE
			check_ptr(p);
			#else
			delete p;
			#endif
			return v;
		}
	}
}
