/*
 * CopyNode.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

#include "stree.h"

#ifdef _SP_MODE
sp_node CopyNode(sp_node s) {
	sp_node t, p, q;
#else
node *CopyNode(node *s) {
	node *t, *p, *q;
#endif

	if (s) {

		t = MakeNode(s->name, s->value);

		if (s == _oldfoot) {
			_newfoot = t;
		}
		q = s->children;
		t->children = CopyNode(q);
		p = t->children;

		while (q) {
			p->sibling = CopyNode(q->sibling);
			q = q->sibling;
			p = p->sibling;
		}

		return t;
	}
	#ifdef _SP_MODE
	sp_node nl;
	return nl;
	#else
	return NULL;
	#endif
}
