/*
 * DeleteNode.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */
#include "stree.h"

#ifdef _SP_MODE
void DeleteNode(sp_node t) {

	sp_node q, p;
#else
void DeleteNode(node *t) {

	node *q, *p;
#endif
	if (t) {
		if (t->children == NULL) {
			#ifdef _SP_MODE
			check_ptr(t);
			#else
			delete t;
			#endif
		} else {
			p = t->children;
			while (p) {
				q = p->sibling;
				DeleteNode(p);
				p = q;
			}
			#ifdef _SP_MODE
			check_ptr(t);
			#else
			delete t;
			#endif
		}
	}
}
