/*
 * GetheightNode.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

#include "stree.h"

#ifdef _SP_MODE
unsigned int GetHeightNode(sp_node t) {
#else
unsigned int GetHeightNode(node *t) {
#endif

	if (t->children == NULL) {
		return 0;
	} else {
		unsigned int c, max = 0;
		#ifdef _SP_MODE
		sp_node p = t->children;
		#else
		node *p = t->children;
		#endif

		while (p) {
			c = GetHeightNode(p);

			if (c > max){
				max = c;
			}

			p = p->sibling;
		}

		return max + 1;
	}
}
