/*
 * NodeCmp.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

#include "stree.h"

#ifdef _SP_MODE
BOOL NodeCmp(sp_node t, sp_node s) {
#else
BOOL NodeCmp(node *t, node *s) {
#endif

	if ((t != NULL) && (s != NULL)) {
		if (!strcmp(t->name, s->name) && (t->value == s->value)) {

			#ifdef _SP_MODE
			sp_node p = t->children;
			sp_node q = s->children;
			#else
			node *p = t->children, *q = s->children;
			#endif
			BOOL b = TRUE;

			while (b && (p != NULL) && (q != NULL)) {
				b = NodeCmp(p, q);
				p = p->sibling;
				q = q->sibling;
			}

			if (b == FALSE) {
				return b;
			} else if ((p == NULL) && (q == NULL)) {
				return TRUE;
			} else {
				return FALSE;
			}

		} else {
			return FALSE;
		}
	} else if ((t == NULL) && (s == NULL)) {
		return TRUE;
	} else {
		return FALSE;
	}
}
