/*
 * StringToTree.cpp
 *
 *  Created on: 2010. 5. 11.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

#include "stree.h"

#ifdef _SP_MODE
sp_node StringToTree() {

	sp_node t;
#else
node *StringToTree() {

	node *t;
#endif
	char n[MAXNAME];
	unsigned int i;

	while (_sbuff[_curchar] == ' ') {
		_curchar++;
	}

	if (isalnum(_sbuff[_curchar])) {
		i = 0;

		while (isalnum(_sbuff[_curchar]) && (i < MAXNAME - 1)) {
			n[i] = _sbuff[_curchar];
			i++;
			_curchar++;
		}

		n[i] = 0;//terminate the string
		t = MakeNode(n, VOIDVALUE);

		if (_sbuff[_curchar] == '~') {
			_sfoot = t;
			_curchar++;
		}

		while (_sbuff[_curchar] == ' ') {
			_curchar++;
		}

		switch (_sbuff[_curchar]) {
		case '(':
			_curchar++;
			t->children = StringToTree();
			_curchar++;

			while (_sbuff[_curchar] == ' '){
				_curchar++;
			}
			//finding for the next sibling
			if (_sbuff[_curchar] == ',') {
				_curchar++;
				t->sibling = StringToTree();
			}
			return t;
		case ')':
			//_curchar++;
			return t;
		case ',':
			_curchar++;
			t->sibling = StringToTree();
			return t;
		case 0:
			return t;//new part
		default:
			cout << "Error in the string";
			exit(1);
		}
	} else {
		cout << "Error in the string";
		exit(1);
	}
	
	#ifdef _SP_MODE
	sp_node nl;
	return nl;
	#else
	return NULL;
	#endif
}
