/*
 * LoadETree.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National U
 */

#include "symregr.h"

void LoadETree() {

	cout << endl << "Loading elementary trees...";
	etree = new stree[20];
	assert(etree!=NULL);
	etree[0] = InitTree("EXP(VAR(X))");
	etree[1] = InitTree("EXP(VAR(R))");
	etree[2] = InitTree("EXP(EXP(VAR(X)),OP(add),EXP~)");
	etree[3] = InitTree("EXP(EXP(VAR(X)),OP(mul),EXP~)");
	etree[4] = InitTree("EXP(EXP(VAR(X)),OP(sub),EXP~)");
	etree[5] = InitTree("EXP(EXP(VAR(X)),OP(div),EXP~)");
	etree[6] = InitTree("EXP(EXP~,OP(add),EXP(VAR(X)))");
	etree[7] = InitTree("EXP(EXP~,OP(mul),EXP(VAR(X)))");
	etree[8] = InitTree("EXP(EXP~,OP(sub),EXP(VAR(X)))");
	etree[9] = InitTree("EXP(EXP~,OP(div),EXP(VAR(X)))");
	etree[10] = InitTree("EXP(EXP(VAR(R)),OP(add),EXP~)");
	etree[11] = InitTree("EXP(EXP(VAR(R)),OP(mul),EXP~)");
	etree[12] = InitTree("EXP(EXP(VAR(R)),OP(sub),EXP~)");
	etree[13] = InitTree("EXP(EXP(VAR(R)),OP(div),EXP~)");
	etree[14] = InitTree("EXP(EXP~,OP(add),EXP(VAR(R)))");
	etree[15] = InitTree("EXP(EXP~,OP(mul),EXP(VAR(R)))");
	etree[16] = InitTree("EXP(EXP~,OP(sub),EXP(VAR(R)))");
	etree[17] = InitTree("EXP(EXP~,OP(div),EXP(VAR(R)))");

	numetree = 18;
	numalpha = 2;
	numbeta = 16;
	cout << "Done!" << endl << flush;
	cout << endl << "Building Vocabulary...";
	BuildVocab();
	cout << "done" << endl << flush;
	cout << "Buiding adjoining table...";
	entrynum = 0;
	BuildAdTable();
	cout << "Done!" << endl << flush;
}
