/*
 * Set2ParseTree.cpp
 *
 *  Created on: 2010. 5. 12.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National Univ.
 */

#include "symregr.h"

#ifdef _SP_MODE
sp_node Stree2ParseTree(sp_node st) {

	sp_node p, q, t, t1, t2;
#else
node *Stree2ParseTree(node *st) {

	node *p, *q, *t, *t1, *t2;
#endif

	if (!strcmp(st->name, "EXP")) {
		p = st->children;
		if (!strcmp(p->name, "EXP")) {//binary oprators
			//get the oprators
			q = p->sibling->children;
			t = MakeNode(q->name, q->value);
			t1 = Stree2ParseTree(p);
			t2 = Stree2ParseTree(p->sibling->sibling);
			t->children = t1;
			t1->sibling = t2;
			t2->sibling = NULL;
			return t;
		} else if (!strcmp(p->name, "PRE")) {
			q = p->children;
			t = MakeNode(q->name, q->value);
			t1 = Stree2ParseTree(p->sibling);
			t->children = t1;
			t1->sibling = NULL;
			return t;
		} else { //VAR
			return Stree2ParseTree(p->children);
		}
	} else {//"X"
		t = MakeNode(st->name, st->value);
		return t;
	}
}
