/*
 * Util.h
 *
 *  Created on: 2010. 5. 27.
 *      Original Author: Nguyen Xuan Hoai
 *      Modifications: Structural Complexity Lab, Seoul National Univ.
 */

#ifndef UTIL_H_
#define UTIL_H_

#include "../genetic/genetic.h"

#ifdef _SP_MODE
void insertBeta(sp_dnode q, sp_dnode p, BYTE addno, sp_dnode t);
void swapTree(unsigned int temp1, sp_dnode & dnode1, sp_dnode & dnode2, llist l, sp_dnode temp2);
void checkXBetaRoot(sp_address & p, sp_dnode dnodeparent, BYTE & i,sp_dnode & dnode1, sp_snode & t, BOOL & found, sp_dnode & dnode2);
void getCrossOverPoints(unsigned int crosspoint, individual & parent, sp_dnode & dnode, sp_dnode & dnodeparent);
void recomputeSizeNBranch(individual & child, individual parent, SIZE & size2, SIZE & size1, sp_dnode dnode);
void swapParents(sp_dnode tp1, sp_dnode dnodeparent1, sp_dnode & dnode1,BYTE addindex, sp_dnode dnodeparent2, BOOL found, sp_dnode tp2);
void randomCut(individual & child1, individual parent1, SIZE & size2, SIZE & size1, sp_dnode dnode1);
void getCrossoverPoints(unsigned int crosspoint, individual & parent, sp_dnode & dnode);
void checkAdjoint(sp_address p, sp_dnode & dnodeparent2, unsigned int i, BYTE & addindex, sp_snode t, BOOL & found2, sp_dnode & dnode1);
void checkAdjoint(sp_address & p, sp_dnode & dnode1, unsigned int i, sp_dnode & q, sp_snode & t, BOOL & found2);
void checkAdjoint(sp_snode & t, sp_address & p, BOOL & found, sp_dnode & q);
void increaseOrderInsert(BOOL found, sp_dnode tp2, sp_dnode tp1, BYTE addindex, sp_dnode & dnode1, sp_dnode dnodeparent2);
void findOpenNode(unsigned int opendnodeno, individual & child, sp_dnode & dnode);
void findNInsert(BOOL found, sp_dnode q, sp_dnode dnode2, sp_dnode p, sp_dnode dnode1);

#else
void insertBeta(dnode * q, dnode * p, BYTE addno, dnode * t);
void swapTree(unsigned int temp1, dnode * & dnode1, dnode * & dnode2, llist l, dnode * temp2);
void checkXBetaRoot(address * & p, dnode * dnodeparent, BYTE & i, dnode * & dnode1, snode * & t, BOOL & found, dnode * & dnode2);
void getCrossOverPoints(unsigned int crosspoint, individual & parent, dnode * & dnodearg, dnode * & dnodeparent);
void recomputeSizeNBranch(individual & child, individual parent, SIZE & size2, SIZE & size1, dnode * dnode);
void swapParents(dnode * tp1, dnode * dnodeparent1, dnode * & dnode1,BYTE addindex, dnode * dnodeparent2, BOOL found, dnode * tp2);
void randomCut(individual & child1, individual parent1, SIZE & size2, SIZE & size1, dnode * dnode1);
void getCrossoverPoints(unsigned int crosspoint, individual & parent, dnode * & dnode);
void checkAdjoint(address * p, dnode * & dnodeparent2, unsigned int i, BYTE & addindex, snode * t, BOOL & found2, dnode * & dnode1);
void checkAdjoint(address * & p, dnode * & dnode1, unsigned int i, dnode * & q, snode * & t, BOOL & found2);
void checkAdjoint(snode * & t, address * & p, BOOL & found, dnode * & q);
void increaseOrderInsert(BOOL found, dnode * tp2, dnode * tp1, BYTE addindex, dnode * & dnode1, dnode * dnodeparent2);
void findOpenNode(unsigned int opendnodeno, individual & child, dnode * & dnode);
void findNInsert(BOOL found, dnode * q, dnode * dnode2, dnode * p, dnode * dnode1);
#endif

void setAct(BOOL fairsize, SIZE & size1, SIZE & size2, unsigned int diff, BOOL & act, individual & parent1, individual & parent2);
void checkAndSetAct(BOOL fairsize, SIZE & size1, SIZE & size2, unsigned int diff, BOOL & act, individual & parent1, individual & parent2);
void copyIndividual(individual & tmp, individual & node1, individual & node2);
void recomputeSizeNBranch(individual & child1, individual & parent1, SIZE & size2, SIZE & size1);
void recomputeSizeNBranch(individual & child, unsigned int & l);

#endif /* UTIL_H_ */


